<template>
  <q-card v-if="dimension" flat @focusout="current = undefined">
    <div :key="language_switch">
      <q-card-section class="text-primary dimension__heading text-weight-bold"
                      @click="show_concept(dimension.concept)" role="heading">
        <div v-html="show_label(dimension.concept)"></div>
      </q-card-section>
      <q-item-label v-if="dimension.concept && dimension.concept.typed_domainref" class="typed_domain">
        typed dimension
      </q-item-label>
      <q-item clickable
              v-on:click="show_concept(dimension.concept)"
              @keypress.enter="show_concept(dimension.concept)"
              :class="{active: current===dimension.concept_id}"
              tabindex="0">
        <span v-html="show_label(dimension.concept)"></span>
      </q-item>
      <template v-if="dimension.members.length">
        <div v-for="member in dimension.members"
             v-bind:key="member.concept_id"
             class="members q-pl-md" >
          <q-item :id="member.concept_id"
                  clickable tabindex="0"
                  v-on:click="show_concept(member.concept)"
                  :class="{active: current===member.concept_id}"
                  class="row">
            <div class="col-9">
              <span class="text-caption">{{ member.type }}:</span>&nbsp;<span v-html="show_label(member)"></span>
            </div>
            <div class="preferred_label col-2" v-if="label_nice_role(member) !== 'label'">{{ label_nice_role(member) }}</div>
          </q-item>

          <template v-if="member.members && member.members.length">
            <div class="q-pl-md" v-for="child in member.members" v-bind:key="child.concept_id">
              <q-item v-on:click="show_concept(child.concept)"
                      class="members q-pl-md row"
                      :id="child.concept_id"
                      clickable
                      tabindex="0"
                      :class="{active: current===child.concept_id}">
                <div class="col-9">
                  <span class="text-caption">{{ child.type }}:</span>&nbsp;<span v-html="show_label(child)"></span>
                </div>
                <div class="preferred_label col-2" v-if="label_nice_role(child) !== 'label'">{{ label_nice_role(child) }}</div>
              </q-item>
              <div class="q-pl-md" v-if="child.members && child.members.length">
                <q-item v-for="grandchild in child.members"
                        v-bind:key="grandchild.concept_id"
                        v-on:click="show_concept(grandchild.concept)"
                        class="members q-pl-md row"
                        :id="grandchild.concept_id"
                        clickable
                        tabindex="0"
                        :class="{active: current===grandchild.concept_id}">
                    <div class="col-9">
                      <span class="text-caption">{{ child.type }}:</span>&nbsp;<span v-html="show_label(grandchild)"></span>
                    </div>
                    <div class="preferred_label col-2" v-if="label_nice_role(grandchild) !== 'label'">{{ label_nice_role(grandchild) }}</div>
                </q-item>
              </div>
            </div>
          </template>
        </div>
      </template>
    </div>
  </q-card>
</template>

<script>
import SharedMethods from "components/SharedMethods";

export default {
  name: "DimensionCard",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  data() {
    return {language_switch: 0, current: undefined}
  },
  methods: {
    show_concept: function (concept) {
      this.current = concept.id
      this.$emit('dim_conceptClicked', concept)
    }
  },
  props: {
    dimension: Object
  },
  watch: {
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    },
    dimension: function () {
      this.current = undefined
    }
  },
  emits: ["dim_conceptClicked"]
}
</script>

<style scoped lang="scss">
.dimension__heading {
  border-bottom: 1px solid $primary;
  font-size: 20px;
  margin-bottom: 10px;
}

.active {
  background-color: $detail_bg;
}

.typed_domain {
  font-variant: small-caps;
  border-left: 5px solid $blue-grey;
  padding: 5px;
  text-align: right;
}

.preferred_label {
  background-color: $detail_bg;
  line-height: 30px;
  padding-left: 10px;
}
</style>
